﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;
using Microsoft.Phone.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.DataBoundListBox;

namespace SampleProject
{
    public partial class MainPage : PhoneApplicationPage, INotifyPropertyChanged
    {
        private ObservableCollection<string> items = new ObservableCollection<string>();
        private Random rand = new Random();

        private DataTemplate footerTemplate;

        public MainPage()
        {
            this.InitializeComponent();
            this.FooterTemplate = this.Resources["FooterTemplate"] as DataTemplate;

            this.LoadData();

            this.dblb.ItemsSource = this.items;
            this.dblb.Loaded += this.DblbLoaded;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public DataTemplate FooterTemplate
        {
            get
            {
                return this.footerTemplate;
            }
            set
            {
                if (this.footerTemplate != value)
                {
                    this.footerTemplate = value;
                    this.OnPropertyChanged("FooterTemplate");
                }
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            var h = this.PropertyChanged;
            if (h != null)
            {
                h(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void DblbLoaded(object sender, System.Windows.RoutedEventArgs e)
        {
            var pull = ElementTreeHelper.FindVisualDescendant<PullToRefreshIndicatorControl>(this.dblb);
            pull.UpdateRefreshTime(DateTime.Today.AddHours(20));
        }

        private void Button_Click1(object sender, System.Windows.RoutedEventArgs e)
        {
            var pull = ElementTreeHelper.FindVisualDescendant<PullToRefreshIndicatorControl>(this.dblb);
            pull.UpdateRefreshTime(DateTime.Now);
        }

        private void Button_Click2(object sender, System.Windows.RoutedEventArgs e)
        {
            this.dblb.StopPullToRefreshLoading(true);
        }

        private void LoadData()
        {
            this.items.Clear();
            for (var i = 0; i < 30; i++)
            {
                this.items.Add(string.Format("item {0}", this.rand.Next()));
            }
        }

        private void ButtonClear_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            this.items.Clear();
            this.FooterTemplate = null;
        }

        private void ButtonPopulate_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            this.LoadData();
            this.FooterTemplate = this.Resources["FooterTemplate"] as DataTemplate;
        }
    }
}